//*****************************************************************************
// File: ResourceCacheEntry.java
// Description: Nirva Java ClassLoader
// Author: Lionel Martin
// Copyright (C) 2013 Nirva Software
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

package com.nirvasoft.nirva;

import java.net.URL;
import java.security.cert.Certificate;
import java.util.jar.Manifest;

public class ResourceCacheEntry {
	private URL source = null;
	private URL codeBase = null;
	volatile Class<?> clazz = null;
	byte[] binaryContent = null;
	Manifest manifest = null;
	Certificate[] certificates;
	
	public ResourceCacheEntry(URL url) {
		this.source = url;
		this.codeBase = url;
	}
	public ResourceCacheEntry(URL url, URL codebase) {
		this.source = url;
		this.codeBase = codebase;
	}
	public URL getUrl() {
		return source;
	}
	public URL getCodeBase() {
		return codeBase;
	}
	public void setUrlsToNull() {
		source = null;
		codeBase = null;
	}
	
}
