//*****************************************************************************
// File: nvcj.java
// Description: Nirva Java client connector
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: The java client connector uses a jni interface and require the nvc dll
// ***************************************************************************************

package com.nirvasoft.nirva;

/**
 * <p>Title: Generique</p>
 * <p>Description: Enterprise Edition</p>
 * <p>Copyright: Copyright 2003 NirvaSoft, Inc. All rights reserved.</p>
 * <p>Company: NIRVASOFT PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.</p>
 * @author Pierre MARC
 * @version 1.0
 */



public class nvcj
{
	private long iHandle;
	public java.lang.String NvResult;

	// Native methods declaration
	private native long Int_OpenRequest(java.lang.String ConnectString);
	private native void Int_CloseRequest(long NvHandle);
	private native int Int_Command(long NvHandle, java.lang.String CommandString);
	private native java.lang.String Int_GetResult(long NvHandle);

	// Load the library
	static
	{
		System.loadLibrary("nvc");
	}

	// constructor with default connection string
	public nvcj()
	{
        iHandle = 0;
		NvResult = "";
		iHandle = Int_OpenRequest("");
	}
	
	// constructor with connection string
	public nvcj(java.lang.String ConnectString)
	{
        iHandle = 0;
		NvResult = "";
        try
		{
			iHandle = Int_OpenRequest(ConnectString);
        }
		catch (Exception e)
		{
	       iHandle = 0;
        }
	}
	
	public int Command(java.lang.String CommandString)
	{
		int RetVal = 0;
		NvResult = "";
		RetVal = Int_Command(iHandle, CommandString);
		if(RetVal == 1)
			NvResult = Int_GetResult(iHandle);
		return RetVal;
	}
	public java.lang.String GetResult(){return Int_GetResult(iHandle);}

	// destructor
	protected void finalize() throws Throwable
	{
		if(iHandle != 0)
			Int_CloseRequest(iHandle);
		iHandle = 0;
		super.finalize();
	}

}

