//*****************************************************************************
// File: NvcxCtl.h
// Description: Nirva ActiveX connector
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

#if !defined(AFX_NVCXCTL_H__305A8E6C_A762_4FCD_9BB8_D0B7BF459B3B__INCLUDED_)
#define AFX_NVCXCTL_H__305A8E6C_A762_4FCD_9BB8_D0B7BF459B3B__INCLUDED_

#include "../nvc/nvc.h"


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// NvcxCtl.h : Declaration of the CNvcxCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CNvcxCtrl : See NvcxCtl.cpp for implementation.

class CNvcxCtrl : public COleControl
{
	DECLARE_DYNCREATE(CNvcxCtrl)

// Constructor
public:
	CNvcxCtrl();
	NVREQUEST hRequest;
	char *ResultBuffer;							// command result buffer
	int ResultBufferSize;						// command result buffer size

	int SetBufferSize(int DataSize);			// eventually allocate or reallocate the result buffer

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNvcxCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CNvcxCtrl();

	DECLARE_OLECREATE_EX(CNvcxCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CNvcxCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CNvcxCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CNvcxCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CNvcxCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CNvcxCtrl)
	CString m_nvResult;
	afx_msg void OnNvResultChanged();
	afx_msg short OpenRequest(LPCTSTR ConnectString);
	afx_msg void CloseRequest();
	afx_msg short Command(LPCTSTR CommandString);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Event maps
	//{{AFX_EVENT(CNvcxCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CNvcxCtrl)
	dispidNvResult = 1L,
	dispidOpenRequest = 2L,
	dispidCloseRequest = 3L,
	dispidCommand = 4L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NVCXCTL_H__305A8E6C_A762_4FCD_9BB8_D0B7BF459B3B__INCLUDED)
